// LinkItem.cpp: implementation of the CLinkItem class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LinkItem.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLinkItem::CLinkItem()
{

	m_bUnderlinedLink	= DEFAULT_UNDERLINED;
	m_clrLink			= DEFAULT_UNVISITED_COLOR;
	m_clrVisited		= DEFAULT_VISITED_COLOR;
	m_hCursorHotSpot	= AfxGetApp()->LoadStandardCursor(IDC_HAND); 
	m_bVisited = FALSE;
	m_strUrl.Empty();

}

CLinkItem::~CLinkItem()
{

}

void CLinkItem::SetLinkProperties(COLORREF clrLink,COLORREF clrVisited,HCURSOR hCursorHotSpot,BOOL bUnderlinedLink ) 
{
									
	m_bUnderlinedLink = bUnderlinedLink;
	m_clrLink = clrLink;
	m_clrVisited = clrVisited;

	if (hCursorHotSpot != NULL) 
	{
		m_hCursorHotSpot = hCursorHotSpot;
	}
}
